/*
   coloranim2.c - displays pictures on an X11 window
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

#include "xslideshow.h"

#define RedPercent      0.299
#define GreenPercent    0.587
#define BluePercent     0.114

typedef struct {
	int	idx;
	double	intensity;
} IntensT;

static IntensT t[256];

static void qsortIntens(int from,int to)
{
    int i,j;
    double mean;
    IntensT tmp;

    i = from;
    j = to;
    mean = (t[i].intensity+t[j].intensity)/2;
    while(1){
        while(t[i].intensity<mean) i++;
        while(t[j].intensity>mean) j--;
        if(i<=j){
            tmp=t[i];t[i]=t[j];t[j]=tmp;
            i++;j--;
        }
        else break;
    }
    if(from<j) qsortIntens(from,j);
    if(i<to) qsortIntens(i,to);
}

static void colorAnimate2()
{
    int i,j;
    XColor xc;

    for (i=0;i<gim.mapsize;i++) {
	t[i].intensity = xcolors[i].red * RedPercent 
			+ xcolors[i].green * GreenPercent 
			+ xcolors[i].blue * BluePercent;
	t[i].idx=i;
    }
    /* Sort color table by it's intensity */
    qsortIntens(0, gim.mapsize-1);
    for(i=0; i<gim.mapsize; i++) if(t[i].intensity != 0) break;
    for(;i<gim.mapsize;i++){
      for(j=0;j<256;j++){
        xc.red  =xcolors[t[i].idx].red   * (word)j / 255;
        xc.green=xcolors[t[i].idx].green * (word)j / 255;
        xc.blue =xcolors[t[i].idx].blue  * (word)j / 255;
        xc.flags=xcolors[t[i].idx].flags;
        xc.pixel=xcolors[t[i].idx].pixel;
	XStoreColor(theDisp, theCmap, &xc);
	XSync(theDisp,False);
      }
      myevent();
    }
}

void xcoloranimate2show(char *fname)	/* color animate2 */
{
    PreDisplay();
    if(app_data.showFileName) createFontWindow(fname);
    ShowImage((windowWidth-gim.width)/2,
		(windowHeight-gim.height)/2,
		gim.width,gim.height);
    colorAnimate2();
    StoreColors(xcolors,gim.mapsize);
    if(app_data.showFileName) raiseFontWindow();
    mysleep(app_data.intervalTime);
}

void postxcoloranimate2show(char *fname)	/* color animate2 */
{
    if(fontWindow != (Window)NULL) removeFontWindow();
}
