/*
   fade.c - displays pictures on an X11 window
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

#include "xslideshow.h"

static int mapsize;
static XColor xcs[256];

static void FadeColors(int mode)
{
    int i,j;

    if(mode){
      for(j=255;j>0;j -= app_data.fadeSteps){
        for(i=0;i<mapsize;i++){
            fcolors[i].red  =xcs[i].red   * (word)j / 255;
            fcolors[i].green=xcs[i].green * (word)j / 255;
            fcolors[i].blue =xcs[i].blue  * (word)j / 255;
            fcolors[i].flags=xcs[i].flags;
            fcolors[i].pixel=xcs[i].pixel;
        }
        StoreColors(fcolors,mapsize);
        myusleep(1000000/app_data.fadeTicks);
      }
    }else{
      for(j=0;j<255;j += app_data.fadeSteps){
        for(i=0;i<mapsize;i++){
            fcolors[i].red  =xcs[i].red   * (word)j / 255;
            fcolors[i].green=xcs[i].green * (word)j / 255;
            fcolors[i].blue =xcs[i].blue  * (word)j / 255;
            fcolors[i].flags=xcs[i].flags;
            fcolors[i].pixel=xcs[i].pixel;
        }
        StoreColors(fcolors,mapsize);
        myusleep(1000000/app_data.fadeTicks);
      }
    }
}

void xfadeshow(char *fname)	/* Fade in */
{
    int i;
    mapsize=gim.mapsize;
    for(i=0; i<mapsize; i++){
	xcs[i].red   = xcolors[i].red;
	xcs[i].green = xcolors[i].green;
	xcs[i].blue  = xcolors[i].blue;
	xcs[i].flags = xcolors[i].flags;
	xcs[i].pixel = xcolors[i].pixel;
    }
    PreDisplay();
    if(app_data.showFileName) createFontWindow(fname);
    ShowImage((windowWidth-gim.width)/2,
		(windowHeight-gim.height)/2,
		gim.width,gim.height);
    if(app_data.showFileName) raiseFontWindow();
    FadeColors(False);
    StoreColors(xcs,mapsize);
    mysleep(app_data.intervalTime);
}

void postxfadeshow(char *fname)	/* Fade out */
{
    FadeColors(True);
    if(app_data.showFileName) removeFontWindow();
}
