/***************************** gif2gimage *******************************

                  Copyright 1993 by Ryuji Oomoto
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

	All the code for reading and converting the GIF image is 
	Ryuji Oomoto's gif2map (oomoto@tppmoon.tpp.epson.co.jp).

	"The Graphics Interchange Format(c) is the Copyright property of
	CompuServe Incorporated. GIF(sm) is a Service Mark property of
	CompuServe Incorporated."

************************************************************************/

#include "xslideshow.h"

#define IEND1   4096
static int count,c,c2,code,cdm,bt0,cd2,cd3,msk,head,ap,pixel;
static int reset_dic,data_end;
static int nd0[IEND1],nd1[IEND1];
static int sft[13],dat[10];
static byte aa0,cc[IEND1],hd[IEND1],h[IEND1];
static long dbyte;
static int varcount;
/*static FILE *fp;*/

static void putsk()
{
	if(code >= IEND1) return;
	h[code]=1;
	hd[code]=head;
	nd0[code]=cd3;
	nd1[code++]=cd2;
	if (code >= cdm) {
		if(bt0 != 12) bt0++;
		cdm=cdm << 1;
	}
}

static int getc12()
{
	while(msk < bt0) {
		if(count == 0) {
			if(feof(fp) != 0) return(ERR_GIF_DATA);
			count=0xff & getc(fp);
			if(count == 0) {
				c2=EOF;
				return(NO_ERR);
			}
		}
		count--;
		if(feof(fp) != 0) return(ERR_GIF_DATA);
		c2=(0xff & getc(fp));
		dbyte=dbyte+((long)c2 << msk);
		msk += 8;
	}
	c=dbyte & sft[bt0];
	dbyte=dbyte >> bt0;
	msk -= bt0;
	return(NO_ERR);
}

int gif2gimage(char *fname)
{
	int i,j,x,y,xmax,ymax;
	int position,interlace,pass,xposi,yposi,yaddr;
	char sign[7];
	int gifversion=0, done=1;
	int status;

	/* Open a GIF file */
	if((fp = fopen(fname,"r")) == NULL) return(ERR_FILE_RW);

	if(app_data.verbose) varcount=0;

	/* Create shift table */
	for(j=1,i=0;i<13;i++) {
		sft[i] = j-1;
		j = (j << 1);
	}

	/* Read GIF SIGNATURE */
	for(i=0;i<6;i++) {
		if(feof(fp) != 0) return(ERR_GIF_DATA);
		sign[i]=0xff & getc(fp);
	}
	sign[i] = (char)NULL;
	if((strncmp(sign, "GIF87a", 6)) == 0)
		gifversion=87;
	else if((strncmp(sign, "GIF89a", 6)) == 0)
		gifversion=89;

	if( gifversion == 0 ){
		if(app_data.verbose) fprintf(stderr,"Can't support %s\n",sign);
		return(ERR_GIF_DATA);
	}

	/* Read SCREEN DESCRIPTOR */
	for(i=0;i<7;i++) {
		if(feof(fp) != 0) return(ERR_GIF_DATA);
		c=0xff & getc(fp);
		if(i == 4) j=c; /* Read Global color map field */
	}

	/* Check Global color map */
	if((j & 0x80) == 0) {
		if(app_data.verbose) fprintf(stderr,"No color table !!\n");
		return(ERR_GIF_DATA);
	}

	/* Check bits per pixel in image */
	pixel=(j & 0x7)+1;

	/* Read color map */
	gim.mapsize=1 << pixel;
	for(i=0;i<gim.mapsize;i++) {
		if(feof(fp) != 0) return(ERR_GIF_DATA);
		gim.red[i]=0xff & getc(fp);	/* Red   */
		if(feof(fp) != 0) return(ERR_GIF_DATA);
		gim.green[i]=0xff & getc(fp);	/* Green */
		if(feof(fp) != 0) return(ERR_GIF_DATA);
		gim.blue[i]=0xff & getc(fp);	/* Blue  */
	}
	for(i=gim.mapsize;i<256;i++) {
		gim.red[i]=0xff;	/* Red   */
		gim.green[i]=0xff;	/* Green */
		gim.blue[i]=0xff;	/* Blue  */
	}

	if(gifversion == 87){
          while(done){
	    if(feof(fp) != 0) return(ERR_GIF_DATA);
            dat[0]=getc(fp);
            if(dat[0]==0x2c){
	    	/* Read IMAGE DESCRIPTOR */
                for(i=1;i<10;i++) {
		    if(feof(fp) != 0) return(ERR_GIF_DATA);
                    dat[i]=getc(fp);
                }
                done=0;
            }
          }
	  /* Read Image Width and Image Height */
          xmax=(dat[6]<<8) | dat[5];
          ymax=(dat[8]<<8) | dat[7];

	}else if(gifversion == 89){
	  while(done){
	    if(feof(fp) != 0) return(ERR_GIF_DATA);
	    dat[0]=0xff & getc(fp);
	    if(feof(fp) != 0) return(ERR_GIF_DATA);
	    dat[1]=0xff & getc(fp);
	    if(dat[0] == 0x21 && dat[1] == 0xf9){
	        /* Skip Graphic Control Extension */
		for(i=0; i<6; i++) {
		    if(feof(fp) != 0) return(ERR_GIF_DATA);
		    getc(fp);
		}
	    }else if(dat[0] == 0x21 && dat[1] == 0xfe){
	        /* Skip Comment Extension */
		while(1){
		    if(feof(fp) != 0) return(ERR_GIF_DATA);
		    if(getc(fp) == 0x00) break;
		}
	    }else if(dat[0] == 0x21 && dat[1] == 0xff){
	        /* Skip Application Extension */
		while(1){
		    if(feof(fp) != 0) return(ERR_GIF_DATA);
		    if(getc(fp) == 0x00) break;
		}
	    }else if(dat[0] == 0x21 && dat[1] == 0x01){
	        /* Skip Plain Text Extension */
		while(1){
		    if(feof(fp) != 0) return(ERR_GIF_DATA);
		    if(getc(fp) == 0x00) break;
		}
	    }else{
	        /* Read IMAGE DESCRIPTOR */
	        for(i=2;i<10;i++) {
		    if(feof(fp) != 0) return(ERR_GIF_DATA);
		    dat[i]=0xff & getc(fp);
	        }
		done=0;
	    }
	  }

	  /* Read Image Width and Image Height */
	  xmax=(dat[6]<<8) | dat[5];
	  ymax=(dat[8]<<8) | dat[7];
	}

	if(app_data.verbose)fprintf(stderr,"(%d x %d)\n",xmax, ymax);

	/* Check if Interlace or Sequential order */
	interlace = ((dat[9] & 0x40) ? True : False);

	/* Read pixel flag field */
	if(feof(fp) != 0) return(ERR_GIF_DATA);
	pixel=0xff & getc(fp);
	reset_dic=(1 << pixel);
	data_end =(1 << pixel)+1;

	if((Image = (byte *)XtCalloc(xmax * ymax, sizeof(byte))) == NULL){
		fprintf(stderr,"Can't allocate memory for Image !!\n");
		goodbyekiss();
	}
	gim.image=Image;
	gim.width=xmax;
	gim.height=ymax;
	
	/* Read RASTER DATA */
	count=0;
	dbyte=0;
	msk=0;
	code=(1 << pixel)+1;
	bt0=pixel+1;
	cdm=(1 << bt0);
	cd2=0;x=0;y=0;
	for(i=0;i<IEND1;i++) h[i]=0;
	if(interlace){
	    xposi=0;
 	    yposi=yaddr=0;
	    pass=1;
	}else{
	    position=0;
	}
	while(1) {
loop:
		status = getc12();
		if(status != NO_ERR) return(status);

		if((c2 == EOF) || (c == data_end)) break;
		if (c == reset_dic) {
			code=(1 << pixel)+1;
			bt0=pixel+1;
			cdm=(1 << bt0);
			for(i=0;i<IEND1;i++) h[i]=0;
			cd2= 0;
			goto loop;
		}
		if (c <  reset_dic) {
			aa0=c;
			if(interlace){
			  if(xposi >= xmax){
			    switch(pass){
			    case 1:
				xposi=0;
				yposi+=8;
				if(yposi >= ymax){
				  yposi=4;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 2:
				xposi=0;
				yposi+=8;
				if(yposi >= ymax){
				  yposi=2;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 3:
				xposi=0;
				yposi+=4;
				if(yposi >= ymax){
				  yposi=1;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 4:
				xposi=0;
				yposi+=2;
				yaddr=yposi*xmax;
				break;
			    }
			  }
			  if(xposi == 0) myevent();
			  if(app_data.verbose && xposi == 0){
                                switch(varcount%4){
                                case 0: fprintf(stderr,"\r|");  break;
                                case 1: fprintf(stderr,"\r/");  break;
                                case 2: fprintf(stderr,"\r-");  break;
                                case 3: fprintf(stderr,"\r\\"); break;
                                default: break;
                                }
                                varcount++;
			  }
			  Image[yaddr+xposi]=c; xposi++;
			}else{
			  if(position % xmax == 0) myevent();
			  if(app_data.verbose && (position % xmax == 0) ){
                                switch(varcount%4){
                                case 0: fprintf(stderr,"\r|");  break;
                                case 1: fprintf(stderr,"\r/");  break;
                                case 2: fprintf(stderr,"\r-");  break;
                                case 3: fprintf(stderr,"\r\\"); break;
                                default: break;
                                }
                                varcount++;
			  }
			  Image[position++]=c;
			}
			x++;if(x == xmax) {x=0;y++;if(y == ymax) goto allend;}
			cd3= c;
			putsk();
			cd2=head=cd3;
			goto loop;
		}
		if(c > code) {
			if(app_data.verbose) fprintf(stderr,"Data error <<%x>>.\n",code);
			return(NO_ERR);
		}
		if (h[c] == 0) cd3=aa0; else cd3= hd[c];
		putsk();
		head=cd3;
		i=c;ap=0;
		while(i >= reset_dic) {
			cc[ap++]=nd0[i];
			i=nd1[i];
		}
		aa0=cc[ap]=i;
		for (i=ap;i >= 0;i--) {
			if(interlace){
			  if(xposi >= xmax){
			    switch(pass){
			    case 1:
				xposi=0;
				yposi+=8;
				if(yposi >= ymax){
				  yposi=4;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 2:
				xposi=0;
				yposi+=8;
				if(yposi >= ymax){
				  yposi=2;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 3:
				xposi=0;
				yposi+=4;
				if(yposi >= ymax){
				  yposi=1;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 4:
				xposi=0;
				yposi+=2;
				yaddr=yposi*xmax;
				break;
			    }
			  }
			  if(xposi == 0) myevent();
			  if(app_data.verbose && xposi == 0){
                                switch(varcount%4){
                                case 0: fprintf(stderr,"\r|");  break;
                                case 1: fprintf(stderr,"\r/");  break;
                                case 2: fprintf(stderr,"\r-");  break;
                                case 3: fprintf(stderr,"\r\\"); break;
                                default: break;
                                }
                                varcount++;
			  }
			  Image[yaddr+xposi]=cc[i]; xposi++;
			} else{
			  if(position % xmax == 0) myevent();
			  if(app_data.verbose && (position % xmax == 0) ){
                                switch(varcount%4){
                                case 0: fprintf(stderr,"\r|");  break;
                                case 1: fprintf(stderr,"\r/");  break;
                                case 2: fprintf(stderr,"\r-");  break;
                                case 3: fprintf(stderr,"\r\\"); break;
                                default: break;
                                }
                                varcount++;
			  }
			  Image[position++]=cc[i];
			}

			x++;if(x == xmax) {x=0;y++;if(y == ymax) goto allend;}
		}
		cd2=c;
		/* goto loop; */
	}

	if(x != 0 && y != ymax){
 	    for(;y<ymax;y++){
		for(;x<xmax;x++){
		    if(interlace){
			  if(xposi >= xmax){
			    switch(pass){
			    case 1:
				xposi=0;
				yposi+=8;
				if(yposi >= ymax){
				  yposi=4;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 2:
				xposi=0;
				yposi+=8;
				if(yposi >= ymax){
				  yposi=2;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 3:
				xposi=0;
				yposi+=4;
				if(yposi >= ymax){
				  yposi=1;
				  pass++;
				}
				yaddr=yposi*xmax;
				break;
			    case 4:
				xposi=0;
				yposi+=2;
				yaddr=yposi*xmax;
				break;
			    }
			  }
			  if(xposi == 0) myevent();
			  if(app_data.verbose && xposi == 0){
                                switch(varcount%4){
                                case 0: fprintf(stderr,"\r|");  break;
                                case 1: fprintf(stderr,"\r/");  break;
                                case 2: fprintf(stderr,"\r-");  break;
                                case 3: fprintf(stderr,"\r\\"); break;
                                default: break;
                                }
                                varcount++;
			  }
			  Image[yaddr+xposi]=0x00; xposi++;
		    }else{
			  if(position % xmax == 0) myevent();
			  if(app_data.verbose && (position % xmax == 0) ){
                                switch(varcount%4){
                                case 0: fprintf(stderr,"\r|");  break;
                                case 1: fprintf(stderr,"\r/");  break;
                                case 2: fprintf(stderr,"\r-");  break;
                                case 3: fprintf(stderr,"\r\\"); break;
                                default: break;
                                }
                                varcount++;
			  }
		          Image[position++]=0x00;
		    }
		}
		x=0;
	    }
	}
allend:
        if(app_data.verbose) fprintf(stderr,"\rgifdone.\n");

	fclose(fp);
	return(NO_ERR);
}

