/***************************** jpg2gimage *******************************

		  Copyright 1993 by Ryuji Oomoto
	      Copyright 1993 by SEIKO EPSON CORPORATION.

			   All Rights Reserved

	All the code for reading and converting the JPG image is 
	Ryuji Oomoto's jpg2rgb (oomoto@tppmoon.tpp.epson.co.jp).

 "JPEG (pronounced "jay-peg") is a standardized image compression mechanism .
 JPEG stands for Joint Photographic Experts Group,the original name of the
 committee that wrote the standard."

************************************************************************/

#include "xslideshow.h"

/* global for decompress */
static byte ***buffer;
static dword **table;
static int iseof,databyte,databit,bitcount,ynum0,yy,ymax,xmax,numcol;
static int zig[64]={
	 0, 1, 8,16, 9, 2, 3,10,
	17,24,32,25,18,11, 4, 5,
	12,19,26,33,40,48,41,34,
	27,20,13, 6, 7,14,21,28,
	35,42,49,56,57,50,43,36,
	29,22,15,23,30,37,44,51,
	58,59,52,45,38,31,39,46,
	53,60,61,54,47,55,62,63
};

/* global for 256 map */
extern short r_max,g_max,b_max;
static long *bfr,*bfg,*bfb;
static long dr,dg,db,dr2,dg2,db2;
static int position,varcount,xallocsize;

static int get_byte()
{
	int i,dmy;
gbyte2:
	if(iseof) i=0;
	else{
		if(feof(fp)) return(ERR_JPG_DATA);
		i=getc(fp);
		if(i == 0xff){
			if(feof(fp)) return(ERR_JPG_DATA);
			dmy=getc(fp);
			if(dmy == 0xd9){
				iseof=1;
				dmy=0;
			}
			if(dmy != 0){
				if(app_data.verbose) fprintf(stderr,"FF+%02x error\n",dmy);
				return(ERR_JPG_DATA);
			}
		}
	}
	databyte=(databyte << 8) | i;
	databit += 8;
	if(databit >= bitcount) return(NO_ERR);
	goto gbyte2;
}

static void jpgdisp()
{
	int i,j,k,l,pix;
	int y,u,v;
	int r,g,b;
	byte *point0,*point1,*point2;

	k=ynum0 << 3;
	l=yy << 3;
	for(j=0;j<k;j++){
		point0= &buffer[0][j][0];
		point1= &buffer[1][j][0];
		point2= &buffer[2][j][0];
		myevent();
		if(app_data.verbose){
			switch(varcount%4){
			case 0: fprintf(stderr,"\r|");  break;
			case 1: fprintf(stderr,"\r/");  break;
			case 2: fprintf(stderr,"\r-");  break;
			case 3: fprintf(stderr,"\r\\"); break;
			default: break;
			}
			varcount++;
		}
		if((l+j) < ymax) for(i=0;i<xmax;i++){
			y= *point0++;
			if(numcol == 1){
				if(y>255) y=255;else if(y<0) y=0;
				r=g=b=y;
			}else{
				y=(y << 6)+32;
				u=(*point1++)-128;
				v=(*point2++)-128;
				r=(y     +v*90) >> 6;
				g=(y-u*22-v*46) >> 6;
				b=(y+u*113    ) >> 6;
				if(r>255) r=255; else if(r<0) r=0;
				if(g>255) g=255; else if(g<0) g=0;
				if(b>255) b=255; else if(b<0) b=0;
			}
			dr=r+(((bfr[i]+bfr[i+3])*2+(bfr[i+1]+bfr[i+2])*3+bfr[i+4])/12);
			dg=g+(((bfg[i]+bfg[i+3])*2+(bfg[i+1]+bfg[i+2])*3+bfg[i+4])/12);
			db=b+(((bfb[i]+bfb[i+3])*2+(bfb[i+1]+bfb[i+2])*3+bfb[i+4])/12);
			dr2=(dr+25)/51;
			dg2=(dg+dg+42)/85;
			db2=(db+25)/51;
			if(dr2<0) dr2=0;else if(dr2>5) dr2=5;
			if(dg2<0) dg2=0;else if(dg2>6) dg2=6;
			if(db2<0) db2=0;else if(db2>5) db2=5;
			pix=((dr2*7)+dg2)*6+db2;
			bfr[i+2]=dr-gim.red[pix];
			bfg[i+2]=dg-gim.green[pix];
			bfb[i+2]=db-gim.blue[pix];
			Image[position++]=pix;
		}
	}
}

static void jpginit()
{
	int i,j;

	if(app_data.verbose)
		fprintf(stderr,"(%d x %d)\n",xmax, ymax);

	xallocsize = xmax + ( xmax % 16 ? (16 - (xmax % 16)) : 0 );
	if(app_data.verbose && app_data.debug)
		fprintf(stderr,"xmax = %d, xallocsize = %d\n",xmax, xallocsize);
	buffer = (byte ***)XtMalloc(sizeof(byte *) * 3);
	for(i=0; i<3; i++){
	  buffer[i] = (byte **)XtMalloc(sizeof(byte *) * 16);
	  for(j=0; j<16; j++){
	    if((buffer[i][j] = (byte *)XtMalloc(sizeof(byte) * xallocsize)) == NULL){
		(void) fprintf(stderr,"Can't allocate memory. Image too big.\n");
		goodbyekiss();
	    }
	  }
	}
	table = (dword **)XtMalloc(sizeof(dword *) * 4);
	for(i=0; i<4; i++){ 
		if((table[i] =(dword *)XtCalloc(4096, sizeof(dword)))==NULL){
			(void) fprintf(stderr,"Can't allocate memory. Image too big.\n");
			goodbyekiss();

		}
	}

	if((Image=(byte *)XtCalloc(xmax * ymax, sizeof(byte)))==NULL){
	        fprintf(stderr,"Can't allocate memory for Image %dx%d!!\n",xmax,ymax);
		goodbyekiss();
	}
	if((bfr=(long *)XtCalloc(xmax + 4,sizeof(long)))==NULL){
	        (void) fprintf(stderr,"Can't allocate memory. Image too big.\n");
		goodbyekiss();;
	}
	if((bfg=(long *)XtCalloc(xmax + 4,sizeof(long)))==NULL){
	        (void) fprintf(stderr,"Can't allocate memory. Image too big.\n");
		goodbyekiss();
	}
	if((bfb=(long *)XtCalloc(xmax + 4,sizeof(long)))==NULL){
	        (void) fprintf(stderr,"Can't allocate memory. Image too big.\n");
		goodbyekiss();
	}
	/* color number = 6*7*6 = 252 */
	for(gim.mapsize=0,dr=0;dr<256;dr += 51){        /* loop 6 */
	        for(dg=0;dg<512;dg += 85){      /* loop 7 */
	                for(db=0;db<256;db += 51){      /* loop 6 */
	                        gim.red[gim.mapsize]=dr;
	                        gim.green[gim.mapsize]=(dg >> 1);
	                        gim.blue[gim.mapsize]=db;
	                        gim.mapsize++;
	                }
	        }
	}

	gim.image=Image;
	gim.width=xmax;
	gim.height=ymax;
	position=varcount=0;
}

static void jpgdone()
{
	int i,j;

	if(buffer){
	 for(i=0; i<3; i++){
	  for(j=0; j<16; j++) XtFree((char *)(buffer[i][j]));
	  XtFree((char *)(buffer[i]));
	 }
	 XtFree((char *)buffer);
	}
	if(table){
	 for(i=0; i<4; i++) XtFree((char *)(table[i]));
	 XtFree((char *)table);
	}
	if(bfr) XtFree((char *)bfr);
	if(bfg) XtFree((char *)bfg);
	if(bfb) XtFree((char *)bfb);

	if(app_data.verbose)
		fprintf(stderr,"\rjpgdone.\n");
}

static int Do_jpg2gimage()
{
	int hufdc[4][2][16],hufac[4][2][256],numac[4],numdc[4];
	int l2,a,n,n2,t,cmax,dri_n,p,k,j,m,cd,i_end,j_end;
	int d,xx,yy2,mcu,x,y,xnum0,comp,xnum,ynum,pp;
	long zcd;
	long zhdc[4][16],zhac[4][256],sft[33],msk[33];
	long zd;
	int  zig_i[64],zig_j[64];
	int  qt[2][64],cmp[256][3],leng[16],col[4],dcsum[4],ndc[4],nac[4];
	int  mono2[8][8],tdc[4],tac[4],xnm[4],ynm[4],qtn[4];
	int  tt[8][8],mm[8][8];
	long ff4,ff5,ff6,ff7,tmp;
	long gg4,gg5,gg6,gg7;
	int  ss0,ss1,ss2,ss3,ss4,ss5,ss6,ss7;
	int  ii,jj,x3,y3,jj3;
	int  *points,c;
	int  i,num_dc,num_ac,num_qt,mm_i,mm_j;
	byte *pointa,*pointb;

	zd=1;
	for(i=0;i<33;i++){
		sft[i]=zd;
		msk[i]=zd-1;
		zd=zd+zd;
	}
	for(i=0;i<4;i++){
		numdc[i]=0;
		numac[i]=0;
		for(j=0;j<16 ;j++) zhdc[i][j]=0;
		for(j=0;j<256;j++) zhac[i][j]=0;
		for(j=0;j<2;j++){
			for(k=0;k<16 ;k++) hufdc[i][j][k]=0;
			for(k=0;k<256;k++) hufac[i][j][k]=0;
		}
	}
	dri_n=0;
	iseof=0;
loop0:
	if(feof(fp)) return(NO_ERR);
	a=getc(fp);
	if(a != 0xff) goto loop0;
	if(feof(fp)) return(NO_ERR);
	a=getc(fp);
	switch(a){

	case 0xd8:
		goto loop0;
	case 0xed: /* Comment field */
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		for(i=0;i<=n;i++){
			if(feof(fp)) return(NO_ERR);
			a=getc(fp);
		}
		goto loop0;
	case 0xe0: /* APPn */
	case 0xfe:
	case 0xee:
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		for(i=3;i<=n;i++){
			if(feof(fp)) return(NO_ERR);
			a=getc(fp);
			if(a < 32) a=32;
			if(a >= 127) a=32;
		}
		goto loop0;
	case 0xdb: /* DQT */
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		while(n != 2){
			if(feof(fp)) return(NO_ERR);
			a=getc(fp);
			if((a & 0xf0) != 0){
				if(app_data.verbose)
					fprintf(stderr,"not 8 bit data\n");
			}
			t=a & 0x0f;
			if(t>=2) return(ERR_JPG_DATA);
			for(i=0;i<64;i++){
				if(feof(fp)) return(NO_ERR);
				qt[t][i]=getc(fp);
			}
			n = n-65;
		}
		goto loop0;
	case 0xc0: /* SOF */
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		if(feof(fp)) return(NO_ERR);
		a=getc(fp);
		if(a != 8){
			if(app_data.verbose) fprintf(stderr,"dct <> 8 bit\n");
			return(NO_ERR);
		}
		if(feof(fp)) return(NO_ERR);
		ymax=getc(fp);
		if(feof(fp)) return(NO_ERR);
		ymax=(ymax << 8)+getc(fp);
		if(feof(fp)) return(NO_ERR);
		xmax=getc(fp);
		if(feof(fp)) return(NO_ERR);
		xmax=(xmax << 8)+getc(fp);
		if(feof(fp)) return(NO_ERR);
		cmax=getc(fp);

		jpginit();	/* Output xmax,ymax and 256 color map */

		for(i=1;i <= cmax;i++){
			if(feof(fp)) return(NO_ERR);
			a=getc(fp);
			if(feof(fp)) return(NO_ERR);
			cmp[a][0]=getc(fp);
			if(feof(fp)) return(NO_ERR);
			cmp[a][1]=getc(fp);
		}
		goto loop0;
	case 0xdd: /* DRI */
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		if(feof(fp)) return(NO_ERR);
		dri_n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		dri_n=(dri_n << 8)+getc(fp);
		goto loop0;
	case 0xfc:
		goto loop0;
	case 0xc4: /* DHT */
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		n= n-2;
dht2:
		if(feof(fp)) return(NO_ERR);
		t=getc(fp);n--;
		if(t > 15) goto dht_ac;
dht_dc:
		if(t>=4) return(ERR_JPG_DATA);
		for(i=0;i<16;i++){
			if(feof(fp)) return(NO_ERR);
			leng[i]=getc(fp);
		}
		n= n-16;
		p=0;zcd=0;bitcount=0;
		for(i=0;i<16;i++){
			k=leng[i];
			for(j=0;j < k;j++){
				if(feof(fp)) return(NO_ERR);
				a=getc(fp);n--;
				if(p >= 16) return(ERR_JPG_DATA);
				hufdc[t][0][p]= i+1;
				hufdc[t][1][p]= a;
				zcd=zcd << (i-bitcount);
				zhdc[t][p]=zcd++;
				p++;bitcount=i;
			}
		}
		numdc[t]=p;
		if(n != 0) goto dht2;
		goto loop0;
dht_ac:
		n= n-16;
		t= t-16;
		if(t>=4) return(ERR_JPG_DATA);
		for(i=0;i<16;i++){
			if(feof(fp)) return(NO_ERR);
			leng[i]=getc(fp);
		}
		p=0;zcd=0;bitcount=0;
		for(i=0;i<16;i++){
			k=leng[i];
			for(j=0;j < k;j++){
				if(feof(fp)) return(NO_ERR);
				a=getc(fp);n--;
				if(p >= 256) return(ERR_JPG_DATA);
				hufac[t][0][p]= i+1;
				hufac[t][1][p]= a;
				zcd=zcd << (i-bitcount);
				zhac[t][p]=zcd++;
				p++;bitcount=i;
			}
		}
		numac[t]=p;
		if(n != 0) goto dht2;
		goto loop0;
	case 0xda: /* SOS */
		if(feof(fp)) return(NO_ERR);
		n=getc(fp);
		if(feof(fp)) return(NO_ERR);
		n=(n << 8)+getc(fp);
		n= n-2;
		if(feof(fp)) return(NO_ERR);
		numcol=getc(fp);
		for(i=0;i < numcol;i++){
			if(feof(fp)) return(NO_ERR);
			k=getc(fp);
			col[i]=k;
			if(feof(fp)) return(NO_ERR);
			cmp[k][2]=getc(fp);
		}
		if(feof(fp)) return(NO_ERR);
		d=getc(fp);if(d != 0   ){
			if(app_data.verbose) fprintf(stderr,"sos error\n");
			return(NO_ERR);
		}
		if(feof(fp)) return(NO_ERR);
		d=getc(fp);if(d != 0x3f){
			if(app_data.verbose) fprintf(stderr,"sos error\n");
			return(NO_ERR);
		}
		if(feof(fp)) return(NO_ERR);
		d=getc(fp);if(d != 0   ){
			if(app_data.verbose) fprintf(stderr,"sos error\n");
			return(NO_ERR);
		}
/*-----------------------------
		start image data
  -----------------------------*/
		xx=0;
		yy=0;
		mcu=0;
		xnum0=cmp[col[0]][0] >> 4;
		ynum0=cmp[col[0]][0] & 0x0f;
		databyte=0;databit=0;
		for(i=0;i<4;i++) dcsum[i]=0;
		for(comp=0;comp<numcol;comp++){
			tdc[comp]=cmp[col[comp]][2] >> 4;
			tac[comp]=cmp[col[comp]][2] & 0xf;
			xnm[comp]=cmp[col[comp]][0] >> 4;
			ynm[comp]=cmp[col[comp]][0] & 0xf;
			qtn[comp]=cmp[col[comp]][1];
			ndc[comp]=numdc[tdc[comp]];
			nac[comp]=numac[tac[comp]];
		}
		for(d=0;d<64;d++){
			zig_i[d]=zig[d] & 0x7;
			zig_j[d]=zig[d] >> 3;
		}
/* set table */
		j=numcol;
		if(j > 2) j=2;
		for(comp=0;comp<j;comp++){
			t=cmp[col[comp]][2] & 0xf;
			if(t>=4) return(ERR_JPG_DATA);
			for(p=0;p<nac[comp];p++){
				if(p >= 256) return(ERR_JPG_DATA);
				bitcount=hufac[t][0][p];
				a=hufac[t][1][p];
				zcd=zhac[t][p];
				if(bitcount <= 12){
					m=sft[12-bitcount];
					a=a | (bitcount << 8);
					for(i=0;i<m;i++){
						table[t][(zcd << (12-bitcount)) | i]=a;
					}
				}
			}
		}
/* end of set table */
loop_xy:
		for(comp=0;comp<numcol;comp++){
			xnum=xnm[comp];
			ynum=ynm[comp];
			num_dc=ndc[comp];
			num_ac=nac[comp];
			num_qt=qtn[comp];
			for(y=0;y<ynum;y++){
				y3=(y << 3);
				for(x=0;x<xnum;x++){
					i_end=0;
					j_end=0;
/* ----------------
	get dc code
   ----------------*/
					pp=1;
get_dc:
					t=tdc[comp];
					for(i=0;i<num_dc;i++){
						bitcount=hufdc[t][0][i];
						if(databit < bitcount) if((get_byte())!=NO_ERR) return(NO_ERR);
						if((databyte >> (databit-bitcount)) == zhdc[t][i]){
							cd=hufdc[t][1][i];
							goto skip_dc1;
						}
					}
					if(app_data.verbose) fprintf(stderr,"huffman dc code error\n");
					return(NO_ERR);
skip_dc1:
					databyte &= msk[databit-bitcount];
					databit  -= bitcount;
					if(cd == 0) goto skip_dc2;
					bitcount=cd;
					if(databit < bitcount) if((get_byte())!=NO_ERR) return(NO_ERR);
					d=(databyte >> (databit-bitcount));
					databyte &= msk[databit-bitcount];
					databit  -= bitcount;
					if(d < sft[bitcount-1]) d=d-sft[bitcount]+1;
					dcsum[comp] += d;
skip_dc2:
					d=dcsum[comp]*qt[num_qt][0];
					if(d >  1023) d=  1023;
					if(d < -1024) d= -1024;
					mm[0][0]=d << 1;
/* ----------------
	get ac code
   ----------------*/
get_ac:
					t=tac[comp];
					if(t >= 4) return(ERR_JPG_DATA);
					n=1;
get_ac1:
					l2=0;
get_ac2:
/* search table */
search_t:
					if(databit >= 12)   i=table[t][databyte >> (databit-12)];
					else	    i=table[t][databyte << (12-databit)];
					bitcount=i >> 8;
					if(databit < bitcount){
						if((get_byte())!=NO_ERR) return(NO_ERR);
						goto search_t;
					}
					if(bitcount != 0){
						cd=i & 0xff;
						goto skip_ac1;
					}
/*end of search table */
					for(i=0;i<num_ac;i++){
						if(i >= 256) return(ERR_JPG_DATA);
						bitcount=hufac[t][0][i];
						if(databit < bitcount) if((get_byte())!=NO_ERR) return(NO_ERR);
						if((databyte >> (databit-bitcount)) == zhac[t][i]){
							cd=hufac[t][1][i];
							goto skip_ac1;
						}
					}
					if(app_data.verbose) fprintf(stderr,"huffman ac code error\n");
					return(NO_ERR);
skip_ac1:
					databyte &= msk[databit-bitcount];
					databit  -= bitcount;
					if(cd == 0){
						while(pp < 64){
							mm[zig_j[pp]][zig_i[pp]]=0;pp++;
						}
						goto end_ac;
					}
					if(cd == 0xf0){
						l2 += 16;
						goto get_ac2;
					}
					n2=(cd >> 4)+l2;
					for(i=0;i<n2;i++){
							mm[zig_j[pp]][zig_i[pp]]=0;pp++;
					}
					n = n+n2+1;
					bitcount = cd & 0x0f;
					if(bitcount == 0){d=0;goto skip_ac2;}
					if(databit < bitcount) if((get_byte())!=NO_ERR) return(NO_ERR);
					d=(databyte >> (databit-bitcount));
					databyte &= msk[databit-bitcount];
					databit  -= bitcount;
					if(d < sft[bitcount-1]) d=d-sft[bitcount]+1;
					d=d*qt[num_qt][pp];
					if(d >  1023) d=  1023;
					if(d < -1024) d= -1024;
skip_ac2:
					mm_i=zig_i[pp];mm_j=zig_j[pp];pp++;
					mm[mm_j][mm_i]= d << 1;
					if(mm_i > i_end) i_end=mm_i;
					if(mm_j > j_end) j_end=mm_j;
					if(n < 64) goto get_ac1;
end_ac:
					if(comp < 3){
idct:
						points = &tt[0][0];
						if(j_end < 2){
							for(i=0;i <= i_end;i++){
								ss0=(mm[0][i]);
								gg4=(mm[1][i]);
								ss4=(gg4*5681) >> 12;
								ss5=(gg4*1130) >> 12;
								ss6=(gg4*4816) >> 12;
								ss7=(gg4*3218) >> 12;
								*points++=(ss0+ss4);*points++=(ss0+ss6);
								*points++=(ss0+ss7);*points++=(ss0+ss5);
								*points++=(ss0-ss5);*points++=(ss0-ss7);
								*points++=(ss0-ss6);*points++=(ss0-ss4);
							}
							goto idct2;
						}
						if(j_end < 4){
							for(i=0;i <= i_end;i++){
								ss4=mm[0][i];
								ss5=((long)mm[2][i]*5352) >> 12;
								ss7=((long)mm[2][i]*2217) >> 12;
								ff4=mm[1][i];
								ff5=((long)mm[3][i]*2896) >> 12;
								ss0=ss4+ss5;    ss1=ss4-ss5;
								ss2=ss4+ss7;    ss3=ss4-ss7;
								gg4=ff4+ff5;    gg6=ff4-ff5;
								tmp=ff4*1130;
								ss4=(gg4*6811-tmp) >> 12;
								ss5=(tmp-ff5*4551) >> 12;
								tmp=(gg6-ff5)*3218;
								ss6=(gg6*8034-tmp) >> 12;
								ss7=(tmp-ff5*1598) >> 12;
								*points++=(ss0+ss4);*points++=(ss2+ss6);
								*points++=(ss3+ss7);*points++=(ss1+ss5);
								*points++=(ss1-ss5);*points++=(ss3-ss7);
								*points++=(ss2-ss6);*points++=(ss0-ss4);
							}
							goto idct2;
						}
						for(i=0;i <= i_end;i++){
							ss4=(mm[0][i]+mm[4][i]);
							ss6=(mm[0][i]-mm[4][i]);
							tmp=((long)mm[2][i]-(long)mm[6][i])*2217;
							ss5=((long)mm[2][i]*7569-tmp) >> 12;
							ss7=(tmp-(long)mm[6][i]*3135) >> 12;
							ff4=(mm[1][i]);
							ff5=(((long)mm[3][i]+(long)mm[5][i])*2896) >> 12;
							ff6=(((long)mm[3][i]-(long)mm[5][i])*2896) >> 12;
							ff7=(mm[7][i]);
							ss0=ss4+ss5;    ss1=ss4-ss5;
							ss2=ss6+ss7;    ss3=ss6-ss7;
							gg4=ff4+ff5;    gg6=ff4-ff5;
							gg5=ff6+ff7;    gg7=ff6-ff7;
							tmp=(gg4-gg5)*1130;
							ss4=(gg4*6811-tmp) >> 12;
							ss5=(tmp-gg5*4551) >> 12;
							tmp=(gg6-gg7)*3218;
							ss6=(gg6*8034-tmp) >> 12;
							ss7=(tmp-gg7*1598) >> 12;
							*points++=(ss0+ss4);*points++=(ss2+ss6);
							*points++=(ss3+ss7);*points++=(ss1+ss5);
							*points++=(ss1-ss5);*points++=(ss3-ss7);
							*points++=(ss2-ss6);*points++=(ss0-ss4);
						}
idct2:
						for(i= i_end+1;i<8;i++){
							*points++=0;*points++=0;*points++=0;*points++=0;
							*points++=0;*points++=0;*points++=0;*points++=0;
						}
						points = &mono2[0][0];
						if(i_end < 2){
							for(i=0;i<8;i++){
								ss0=(tt[0][i]);
								gg4=(tt[1][i]);
								ss4=(gg4*5681) >> 12;
								ss5=(gg4*1130) >> 12;
								ss6=(gg4*4816) >> 12;
								ss7=(gg4*3218) >> 12;
								c=(((ss0+ss4)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0+ss6)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0+ss7)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0+ss5)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0-ss5)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0-ss7)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0-ss6)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0-ss4)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
							}
							goto idct3;
						}
						if(i_end < 4){
							for(i=0;i<8;i++){
								ss4=tt[0][i];
								ss5=((long)tt[2][i]*5352) >> 12;
								ss7=((long)tt[2][i]*2217) >> 12;
								ff4=tt[1][i];
								ff5=((long)tt[3][i]*2896) >> 12;
								ss0=ss4+ss5;    ss1=ss4-ss5;
								ss2=ss4+ss7;    ss3=ss4-ss7;
								gg4=ff4+ff5;    gg6=ff4-ff5;
								tmp=ff4*1130;
								ss4=(gg4*6811-tmp) >> 12;
								ss5=(tmp-ff5*4551) >> 12;
								tmp=(gg6-ff5)*3218;
								ss6=(gg6*8034-tmp) >> 12;
								ss7=(tmp-ff5*1598) >> 12;
								c=(((ss0+ss4)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss2+ss6)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss3+ss7)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss1+ss5)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss1-ss5)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss3-ss7)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss2-ss6)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
								c=(((ss0-ss4)+8) >> 4)+128;
								if(c<0) c=0;else if(c>255) c=255;*points++=c;
							}
							goto idct3;
						}
						for(i=0;i<8;i++){
							ss4=(tt[0][i]+tt[4][i]);
							ss6=(tt[0][i]-tt[4][i]);
							tmp=((long)tt[2][i]-(long)tt[6][i])*2217;
							ss5=((long)tt[2][i]*7569-tmp) >> 12;
							ss7=(tmp-(long)tt[6][i]*3135) >> 12;
							ff4=(tt[1][i]);
							ff5=(((long)tt[3][i]+(long)tt[5][i])*2896) >> 12;
							ff6=(((long)tt[3][i]-(long)tt[5][i])*2896) >> 12;
							ff7=(tt[7][i]);
							ss0=(ss4+ss5);ss1=(ss4-ss5);
							ss2=(ss6+ss7);ss3=(ss6-ss7);
							gg4=ff4+ff5;    gg6=ff4-ff5;
							gg5=ff6+ff7;    gg7=ff6-ff7;
							tmp=(gg4-gg5)*1130;
							ss4=(gg4*6811-tmp) >> 12;
							ss5=(tmp-gg5*4551) >> 12;
							tmp=(gg6-gg7)*3218;
							ss6=(gg6*8034-tmp) >> 12;
							ss7=(tmp-gg7*1598) >> 12;
							c=(((ss0+ss4)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss2+ss6)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss3+ss7)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss1+ss5)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss1-ss5)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss3-ss7)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss2-ss6)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
							c=(((ss0-ss4)+8) >> 4)+128;
							if(c<0) c=0;else if(c>255) c=255;*points++=c;
						}
idct3:
						x3=((xx+x) << 3);
						points = &mono2[0][0];
						if(xnum0 != xnum) goto set_d2;
						if(ynum0 != ynum) goto setd12;
setd11:
						for(jj=0;jj<8;jj++){
							pointa = &buffer[comp][y3+jj][x3];
							if(app_data.verbose && app_data.debug){
								if(x3+8 > xallocsize)
								fprintf(stderr,"Caution!! Memory write over. %d > %d\n", x3+8, xallocsize);
							}
							*pointa++= *points++;*pointa++= *points++;
							*pointa++= *points++;*pointa++= *points++;
							*pointa++= *points++;*pointa++= *points++;
							*pointa++= *points++;*pointa++= *points++;
						}
						goto set_end;
setd12:
						for(jj=0;jj<8;jj++){
							jj3=y3+(jj << 1);
							pointa = &buffer[comp][jj3  ][x3];
							pointb = &buffer[comp][jj3+1][x3];
							if(app_data.verbose && app_data.debug){
								if(x3+8 > xallocsize)
								fprintf(stderr,"Caution!! Memory write over. %d > %d\n", x3+8, xallocsize);
							}
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointb++=c;
						}
						goto set_end;
set_d2:
						if(ynum0 != ynum) goto setd22;
setd21:
						for(jj=0;jj<8;jj++){
							pointa = &buffer[comp][y3+jj][x3];
							if(app_data.verbose && app_data.debug){
								if(x3+16 > xallocsize)
								fprintf(stderr,"Caution!! Memory write over. %d > %d\n", x3+16, xallocsize);
							}
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
							c= *points++;*pointa++=c;*pointa++=c;
						}
						goto set_end;
setd22:
						for(jj=0;jj<8;jj++){
							jj3=y3+(jj << 1);
							if(app_data.verbose && app_data.debug){
								if(x3+16 > xallocsize)
								fprintf(stderr,"Caution!! Memory write over. %d > %d\n", x3+16, xallocsize);
							}
							pointa = &buffer[comp][jj3  ][x3];
							pointb = &buffer[comp][jj3+1][x3];
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
							c= *points++;*pointa++=c;*pointa++=c;*pointb++=c;*pointb++=c;
						}
set_end:
						{}
					}
				} /* next x */
			} /* next y */
		} /* next comp */
		mcu++;
		if(dri_n){
			if(dri_n == mcu){
				databyte=0;databit=0;
wait_ffd0:
				if(feof(fp)) return(NO_ERR);
				ii=getc(fp);
				if(ii == EOF){iseof=1;goto wait_end;}
				if(ii != 255) goto wait_ffd0;
				if(feof(fp)) return(NO_ERR);
				ii=getc(fp);
				if(ii == EOF){iseof=1;goto wait_end;}
				ii=(ii & 0xf8);
				if(ii != 0xd0) goto wait_ffd0;
				mcu=0;
				for(ii=0;ii<4;ii++) dcsum[ii]=0;
			}
		}
wait_end:
		xx += xnum0;
		if((xx << 3) < xmax) goto loop_xy;
		else{
			jpgdisp();
			xx=0;
			yy += ynum0;
			yy2=(yy/100);
			if(iseof) goto allend;
			if((yy << 3) < ymax) goto loop_xy;
		}
	}
allend:
	return(NO_ERR);
}

int jpg2gimage(char *fname)
{
	int status;

	if((fp=fopen(fname,"r"))==NULL) return(ERR_FILE_RW);
	buffer=NULL;
	table=NULL;
	bfr=bfg=bfb=NULL;
	status=Do_jpg2gimage();
	jpgdone();
	fclose(fp);
	return(status);
}
