/*
   move.c - displays pictures on an X11 window
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

#include "xslideshow.h"

static Window imageWindow=(Window)NULL;

static void createImage()
{
    int		x,y,w,h;

    x=(movep ? -gim.width:windowWidth);
    y=(windowHeight-gim.height)/2;
    w=gim.width;
    h=gim.height;
    ShowWindow(&imageWindow, x, y, w, h);
}

static void moveImage()	/* Moving picture */
{
    int		x,y,w,h;

    x=(movep ? -gim.width:windowWidth);
    y=(windowHeight-gim.height)/2;
    w=gim.width;
    h=gim.height;

    if(movep){
     for(;x<windowWidth;x+=app_data.moveSteps){
	XMoveWindow(theDisp,imageWindow,x,y);
	myusleep(1000000/app_data.moveTicks);
     }
    }else{
     for(;x>-gim.width;x-=app_data.moveSteps){
	XMoveWindow(theDisp,imageWindow,x,y);
	myusleep(1000000/app_data.moveTicks);
     }
    }
    movep=!movep;
}

void xmoveshow(char *fname)
{
    PreDisplay();
    if(app_data.showFileName) createFontWindow(fname);
    createImage ();
    StoreColors(xcolors,gim.mapsize);
    if(app_data.showFileName) raiseFontWindow();
    moveImage ();
    removeWindow(&imageWindow);
}

void postxmoveshow(char *fname)
{
    if(fontWindow != (Window)NULL) removeFontWindow();
}

