/*
   resource.h
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

/* Define options */
static XtResource resources[]={

/* Stuff option */
{"debug", "Debug", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, debug), XtRString, "False"},
{"verbose", "Verbose", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, verbose), XtRString, "False"},

/* Display option */
{"root", "Root", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, root), XtRString, "False"},
{"private", "Private", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, private), XtRString, "False"},
{"color", "Color", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, color), XtRImmediate, (caddr_t)254},
{"full", "Full", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, full), XtRString, "False"},
{"override", "Override", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, override), XtRString, "False"},
{"resize", "Resize", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, resize), XtRString, "False"},

/* JPEG option */
{"readJPEG", "ReadJPEG", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, readJPEG), XtRString, "True"},

/* SlideShow option */
{"showFileName", "ShowFileName", XtRBoolean, sizeof(Boolean),
	XtOffset(ApplicationDataPtr, showFileName), XtRString, "True"},
{XtNfont, XtCFont, XtRFontStruct, sizeof(XFontStruct *),
	XtOffset(ApplicationDataPtr, font), XtRString, "vr-40"},
{"intervalTime", "IntervalTime", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, intervalTime), XtRImmediate, (caddr_t)5},
{"fileSelectionMode", "FileSelectionMode", XtRString, sizeof(char *),
	XtOffset(ApplicationDataPtr, fileSelectionMode), XtRString, "random"},

/* Animate option */
{"animate", "Animate", XtRString, sizeof(char *),
	XtOffset(ApplicationDataPtr, animate), XtRString, "slide"},
{"fadeSteps", "FadeSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, fadeSteps), XtRImmediate, (caddr_t)2},
{"fadeTicks", "FadeTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, fadeTicks), XtRImmediate, (caddr_t)35},
{"wipeSteps", "WipeSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, wipeSteps), XtRImmediate, (caddr_t)2},
{"wipeTicks", "WipeTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, wipeTicks), XtRImmediate, (caddr_t)35},
{"moveSteps", "MoveSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, moveSteps), XtRImmediate, (caddr_t)2},
{"moveTicks", "MoveTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, moveTicks), XtRImmediate, (caddr_t)250},
{"blockSteps", "BlockSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, blockSteps), XtRImmediate, (caddr_t)8},
{"monotoneSteps", "MonotoneSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, monotoneSteps), XtRImmediate, (caddr_t)2},
{"monotoneTicks", "MonotoneTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, monotoneTicks), XtRImmediate, (caddr_t)15},
{"flushCount", "FlushCount", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, flushCount), XtRImmediate, (caddr_t)3},
{"flushSteps", "FlushSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, flushSteps), XtRImmediate, (caddr_t)2},
{"flushTicks", "FlushTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, flushTicks), XtRImmediate, (caddr_t)150},
{"reverseSteps", "ReverseSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, reverseSteps), XtRImmediate, (caddr_t)2},
{"reverseTicks", "ReverseTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, reverseTicks), XtRImmediate, (caddr_t)15},
{"colorAnimSort", "ColorAnimSort", XtRString, sizeof(char *),
	XtOffset(ApplicationDataPtr, colorAnimSort), XtRString, "quick"},
{"colorAnimTicks", "ColorAnimTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, colorAnimTicks), XtRImmediate, (caddr_t)10},
{"shuffleSort", "ShuffleSort", XtRString, sizeof(char *),
	XtOffset(ApplicationDataPtr, shuffleSort), XtRString, "quick"},
{"shuffleSteps", "ShuffleSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, shuffleSteps), XtRImmediate, (caddr_t)100},
{"shuffleTicks", "ShuffleTicks", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, shuffleTicks), XtRImmediate, (caddr_t)10},
{"puzzleSteps", "PuzzleSteps", XtRInt, sizeof(int),
	XtOffset(ApplicationDataPtr, puzzleSteps), XtRImmediate, (caddr_t)100},

/* File list */
{"fileList", "FileList", XtRString, sizeof(char *),
	XtOffset(ApplicationDataPtr, fileList), XtRString, ""}
};

/* Define command line options */
static XrmOptionDescRec options[]={
	{"-root",    "*root",    XrmoptionNoArg, "True"},
	{"-private", "*private", XrmoptionNoArg, "True"},
	{"-color",   "*color",   XrmoptionSepArg, ""},
	{"-full",    "*full",    XrmoptionNoArg, "True"},
	{"-override","*override",XrmoptionNoArg, "True"},
	{"-resize",  "*resize",  XrmoptionNoArg, "True"},
	{"-verbose", "*verbose", XrmoptionNoArg, "True"},
	{"-debug",   "*debug",   XrmoptionNoArg, "True"},
	{"-animate", "*animate", XrmoptionSepArg, ""}
};


/* Define default options */
static char *defaults[]={
  "*geometry:           600x480",
  "*foreground:         White",
  "*background:         Black",
  0
};

