/*
   slide.c - displays pictures on an X11 window
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

#include "xslideshow.h"

static Window imageWindow=(Window)NULL;
static int slideWindowX,slideWindowY,slideWindowW,slideWindowH;

void xslideshow(char *fname)
{
    int x, y;

    PreDisplay();
    StoreColors(xcolors,gim.mapsize);

    x=(windowWidth-gim.width)/2;
    y=windowHeight+gim.height;
    slideWindowW=gim.width;
    slideWindowH=gim.height;
    ShowWindow( &imageWindow, x, y, slideWindowW, slideWindowH);
    if(app_data.showFileName) createFontWindow(fname);

    slideWindowX = (windowWidth-gim.width)/2;
    slideWindowY = (windowHeight-gim.height)/2;
#if True
    move_on_bresenham_line(imageWindow, 
		x, y, slideWindowX, slideWindowY, 10);
#else
    warp(imageWindow, x, y, slideWindowX, slideWindowY, 10);
#endif

    if(app_data.showFileName) raiseFontWindow();
    mysleep(app_data.intervalTime);
}


void postxslideshow(char *fname)
{
    if(imageWindow != (Window)NULL) {
#if True
          move_on_bresenham_line(imageWindow,
                          slideWindowX, slideWindowY,
                          slideWindowX, -slideWindowH, 10);
#else
          warp(imageWindow, slideWindowX, slideWindowY,
                          slideWindowX, -slideWindowH, 10);
#endif
          removeWindow(&imageWindow);
    }
    if(fontWindow != (Window)NULL) removeFontWindow();
}
