/*
   wipe.c - displays pictures on an X11 window
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

#include "xslideshow.h"

static int wipeW, wipeH, windowW, windowH;

static void wipeImage(int mode)	/* Wipe in,Wipe out */
{
    Pixmap      pic;
    XGCValues	gcv;
    GC		gc;
    int		sx,sy,dx,dy,w,h,drawWidth,drawHeight;
    int		src_x,src_y,dst_x,dst_y,size;

    src_x=wipeW/2; src_y=wipeH/2;
    dst_x=windowW/2; dst_y=windowH/2;
    drawWidth=(wipeW>windowW ? windowW:wipeW);
    drawHeight=(wipeH>windowH ? windowH:wipeH);

    if(mode){ /* WIPE IN */
	gcv.function=GXcopy;gc=XCreateGC(theDisp,theWindow,GCFunction,&gcv );
	if((pic=XCreatePixmap(theDisp,theWindow,wipeW,wipeH,
		DefaultDepth(theDisp,theScreenNumber)))==(Pixmap)NULL){
		fprintf(stderr,"Can't create Pixmap. Abort.\n");
		goodbyekiss();
	}
	XPutImage(theDisp,pic,gc,theImage,0,0,0,0,wipeW,wipeH);

        XCopyArea(theDisp,pic,theWindow,gc,
	    	src_x-app_data.wipeSteps/2,src_y-app_data.wipeSteps/2,
		app_data.wipeSteps,app_data.wipeSteps,
		dst_x-app_data.wipeSteps/2,dst_y-app_data.wipeSteps/2);
        for(size=app_data.wipeSteps;
	    size<(drawWidth>drawHeight ? drawWidth/2:drawHeight/2);
	    size+=app_data.wipeSteps){
          myusleep(1000000/app_data.wipeTicks);
	  sx=src_x-size;sy=src_y-size;
	  dx=dst_x-size;dy=dst_y-size;
	  w=size*2;h=app_data.wipeSteps;
          XCopyArea(theDisp,pic,theWindow,gc,sx,sy,w,h,dx,dy);
	  sx=src_x+size;sy=src_y-size;
	  dx=dst_x+size;dy=dst_y-size;
	  w=app_data.wipeSteps;h=size*2;
          XCopyArea(theDisp,pic,theWindow,gc,sx,sy,w,h,dx,dy);
	  sx=src_x-size+app_data.wipeSteps;sy=src_y+size;
	  dx=dst_x-size+app_data.wipeSteps;dy=dst_y+size;
	  w=size*2;h=app_data.wipeSteps;
          XCopyArea(theDisp,pic,theWindow,gc,sx,sy,w,h,dx,dy);
	  sx=src_x-size;sy=src_y-size+app_data.wipeSteps;
	  dx=dst_x-size;dy=dst_y-size+app_data.wipeSteps;
	  w=app_data.wipeSteps;h=size*2;
          XCopyArea(theDisp,pic,theWindow,gc,sx,sy,w,h,dx,dy);
        }
	XFreeGC(theDisp,gc);XFreePixmap(theDisp,pic);

    }else{ /* WIPE OUT */
        for(size=(drawWidth>drawHeight ? drawWidth/2:drawHeight/2)-1;
	    size>0;
	    size-=app_data.wipeSteps){
          myusleep(1000000/app_data.wipeTicks);
	  dx=dst_x-size;dy=dst_y-size;
	  w=size*2;h=app_data.wipeSteps;
          XClearArea(theDisp,theWindow,dx,dy,w,h,False);
	  dx=dst_x+size;dy=dst_y-size;
	  w=app_data.wipeSteps;h=size*2;
          XClearArea(theDisp,theWindow,dx,dy,w,h,False);
	  dx=dst_x-size+app_data.wipeSteps;dy=dst_y+size;
	  w=size*2;h=app_data.wipeSteps;
          XClearArea(theDisp,theWindow,dx,dy,w,h,False);
	  dx=dst_x-size;dy=dst_y-size+app_data.wipeSteps;
	  w=app_data.wipeSteps;h=size*2;
          XClearArea(theDisp,theWindow,dx,dy,w,h,False);
        }
        XClearArea(theDisp,theWindow,
		dst_x-app_data.wipeSteps/2,dst_y-app_data.wipeSteps/2,
		app_data.wipeSteps,app_data.wipeSteps,False);
    }
}

void xwipeshow(char *fname)
{
    wipeW=gim.width;
    wipeH=gim.height;
    windowW=windowWidth;
    windowH=windowHeight;

    PreDisplay();
    StoreColors(xcolors,gim.mapsize);
    if(app_data.showFileName) createFontWindow(fname);
    wipeImage(True);
    if(app_data.showFileName) raiseFontWindow();
    mysleep(app_data.intervalTime);
}

void postxwipeshow(char *fname)
{
    wipeImage(False);
    if(app_data.showFileName) removeFontWindow();
}
