/*
   xslideshow.c - displays pictures on an X11 window
   Author:   Susumu Shiohara,SEIKO EPSON Corp.  (shiohara@io.tpp.epson.co.jp)

                  Copyright 1993 by Susumu Shiohara
              Copyright 1993 by SEIKO EPSON CORPORATION.

                           All Rights Reserved

*/

#include "xslideshow.h"
#include <X11/cursorfont.h>

static int post=0;

int AnimateShow(Widget topWidget,char *fname)
{
    Arg args[5];
    int ac;
    int errf;
    int d_h,f_a,f_d;
    XCharStruct overall;
    XSetWindowAttributes  swa;

    if(!app_data.root){
	swa.cursor=XCreateFontCursor(theDisp,XC_watch);
	XChangeWindowAttributes(theDisp,theWindow,CWCursor,&swa);
    }

    if((errf=checkFileType(fname)) != NO_ERR) return(errf);
    gim.image=(byte *)NULL;
    if(fileType==IS_GIF){
      if((errf=gif2gimage(fname)) != NO_ERR) {
	if(gim.image) XtFree((char *)(gim.image));
	if(app_data.verbose) fprintf(stderr,"GIF read error.\n");
	return(errf);
      }
    }else if(fileType==IS_JPG){
      if(app_data.readJPEG){
	if((errf=jpg2gimage(fname)) != NO_ERR) {
	  if(gim.image) XtFree((char *)(gim.image));
	  if(app_data.verbose) fprintf(stderr,"JPEG read error.\n");
	  return(errf);
	}
      }else{
	return(NO_ERR);
      }
    }else {
	return(NO_ERR);
    }
    if(!gim.image) {
	if(app_data.verbose) fprintf(stderr,"gim.image is NULL.\n");
	return(NO_ERR);
    }
    if(gim.mapsize > 256) {
	if(gim.image) XtFree((char *)(gim.image));
	if(app_data.verbose) fprintf(stderr,"gim.mapsize = %d\n",gim.mapsize);
	return(NO_ERR);
    }

    if((errf=CreateXImage()) != NO_ERR) {
	if(gim.image) XtFree((char *)(gim.image));
	if(app_data.verbose) fprintf(stderr,"Can't create XImage\n");
	return(errf);
    }

    if(!app_data.root){
	swa.cursor=XCreateFontCursor(theDisp,XC_coffee_mug);
	XChangeWindowAttributes(theDisp,theWindow,CWCursor,&swa);
    }

    if(!app_data.debug){
	if(post) {
		postAnimateFunc[animate_strtoenum()](fname);
		XSync(theDisp,False);
	}
	if(!app_data.root && !app_data.full && !app_data.resize){
		windowWidth=newWindowWidth;
		windowHeight=newWindowHeight;
	}
	if(!app_data.root && !app_data.full && app_data.resize){
		windowWidth=gim.width;
		windowHeight=gim.height;
		XTextExtents(app_data.font,"Resize the Window.",
			strlen("Resize the Window."),
			&d_h,&f_a,&f_d,&overall);
		windowHeight=windowHeight+(overall.descent+overall.ascent)*2;
		ac=0;
		XtSetArg(args[ac],XtNwidth,windowWidth);ac++;
		XtSetArg(args[ac],XtNheight,windowHeight);ac++;
		XtSetValues(topWidget,args,ac);
		XSync(theDisp,False);
	}
	animateFunc[animate_strtoenum()](fname);
	post=1;
    }
    FreeXImage();
    return(NO_ERR);
}

