.\" Copyright (c) 1993 SEIKO EPSON CORPORATION. Susumu Shiohara
.TH XSlideShow 1 "24-jan-94" "X Version 11"
.SH NAME
xslideshow - Image viewer on the X Window System.
.SH SYNOPSIS
.B xslideshow
[\-animate \fIstring\fP] [\-root] [\-private] [\-color \fIint\fP] [\-full] [\-override] [\-resize] [\fIfilelist\fP]
.SH DESCRIPTION
Xslideshow is an image processing and display program. It can display an image on any workstation display running an X server.
The features of Xslideshow are the animation display image files.

.SH ANIMATION
.I xslideshow
accepts one of the following animation options. 
.TP 8
.B slide
Slide show.
.TP 8
.B fade
Fade-in, Fade-out.
.TP 8
.B flush
Flush.
.TP 8
.B monotone
Fade-in, Monotone, Color, Fade-out.
.TP 8
.B reverse
Fade-in, Reverse-color, Reverse-color, Fade-out.
.TP 8
.B wipe
Wipe-in, Wipe-out.
.TP 8
.B block
Divides the image into small blocks, and shows the blocks randomly.
.TP 8
.B mosaic
Displays a detailed mosaic image.
.TP 8
.B coloranim
Randomizes color index table and sorts by specified sorting algorithm.
.TP 8
.B coloranim2
Take out one color from the color index table, and put it. Repeat for all colors.
.TP 8
.B shuffle
Divides the image into blocks and displays each block randomly on
the screen. The correct image is displayed by exchanging the
blocks.
.TP 8
.B puzzle
Same as shuffle, except the image is formatted by solving the sequence of the blocks as in 15 block puzzle.
.TP 8
.B move
The image is brought into view slowly from right to left.

.SH OPTIONS
The following options affect the global operation of xslideshow.
They may be specified anywhere on the command line.
.TP 8
.B \-animate \fIstring\fP
Specifies animation mode with one of the following options:
slide, fade, reverse, wipe, block, mosaic, coloranim, shuffle, puzzle, move.
.TP 8
.B \-root
Displays on the Root Window.
.TP 8
.B \-private
Forces to use the private colormap.
Without this option, the colors are allocated shared colormap unless there are not enough colors available.
.TP 8
.B \-color \fIinteger\fP
Specifies the maximum number of colors to use in the image.
This is a way to forcibly reduce the depth of an image.
.TP 8
.B \-full
Uses the entire screen to display images.
.TP 8
.B \-override
Create the override_redirect window when -full option is specified.
.TP 8
.B \-resize
Uses the image size to display images.
.TP 8
.B filelist
Specifies the list of files.

.SH X RESOURCES
\fIxslideshow\fP understands the following resources
.PP
.TP 8
.B readJPEG \fR(class \fBBoolean\fP)
Specify to read JPEG file. If False, xslideshow pass by JPEG files.
Default boolean is True.
.TP 8
.B showFileName \fR(class \fBBoolean\fP)
Specify to show the file name.
Default boolean is True.
.TP 8
.B fontName \fR(class \fBString\fP)
Specify the font name.
Default string is "vr-40"
.TP 8
.B color \fR(class \fBInteger\fP)
Specify the color number showing pictures.
Default value is 254 (colors).
.TP 8
.B intervalTime \fR(class \fBTime\fP)
Specify the interval time switching pictures.
Default value is 5 (sec).
.TP 8
.B fileSelectionMode \fR(class \fBString\fP)
Specify the file selection mode. (sequent, random)
Default string is "random".
.TP 8
.B animate \fR(class \fBString\fP)
Specify the animation mode.
(slide, fade, flush, monotone, reverse, wipe, block, mosaic, coloranim, coloranim2, shuffle, puzzle, move)
Default string is "slide".
.TP 8
.B fadeSteps \fR(class \fBInteger\fP)
Specify the fading steps of color intense(0 to 256).
Default value is 2.
.TP 8
.B fadeTicks \fR(class \fBInteger\fP)
Specify the fading ticks. Change intense by (1000000/fadeTicks) micro sec.
Default value is 35. 
.TP 8
.B wipeSteps \fR(class \fBInteger\fP)
Specify the wiping steps.
Default value is 2.
.TP 8
.B wipeTicks \fR(class \fBInteger\fP)
Specify the wiping ticks. Wipe by (1000000/wipeTicks) micro sec.
Default value is 35. 
.TP 8
.B moveSteps \fR(class \fBInteger\fP)
Specify the moving factor. 
Default value is 2 (pixel).
.TP 8
.B moveTicks \fR(class \fBInteger\fP)
Specify the moving ticks. Move by (1000000/moveTicks) micro sec.
Default value is 250. 
.TP 8
.B blockSteps \fR(class \fBInteger\fP)
Specify the block size.
Default value is 8 (pixels).
.TP 8
.B monotoneSteps \fR(class \fBInteger\fP)
Specify the monotone steps of color intense(0 to 256).
Default value is 2.
.TP 8
.B monotoneTicks \fR(class \fBInteger\fP)
Specify the monotone ticks. Change intense by (1000000/monotoneTicks) micro sec.
Default value is 15. 
.TP 8
.B flushCount \fR(class \fBInteger\fP)
Specify the flushing count.
Default value is 3.
.TP 8
.B flushSteps \fR(class \fBInteger\fP)
Specify the flushing steps of color intense(0 to 256).
Default value is 2.
.TP 8
.B flushTicks \fR(class \fBInteger\fP)
Specify the flushing ticks. Change intense by (1000000/flushTicks) micro sec.
Default value is 150. 
.TP 8
.B reverseSteps \fR(class \fBInteger\fP)
Specify the reversing steps of color intense(0 to 256).
Default value is 2.
.TP 8
.B reverseTicks \fR(class \fBInteger\fP)
Specify the reversing ticks. Change intense by (1000000/reverseTicks) micro sec.
Default value is 15. 
.TP 8
.B colorAnimSort \fR(class \fBString\fP)
Specify the sorting algorithm. (bubble,shell,quick)
Default string is "quick".
.TP 8
.B colorAnimTicks \fR(class \fBInteger\fP)
Specify the color animation ticks. Sort color map index by (1000000/colorAnimTicks) micro sec.
Default value is 10. 
.TP 8
.B shuffleSort \fR(class \fBString\fP)
Specify the sorting algorithm. (bubble,shell,quick)
Default string is "quick".
.TP 8
.B shuffleSteps \fR(class \fBInteger\fP)
Specify the block size.
Default value is 100 (100x100 pixels).
.TP 8
.B shuffleTicks \fR(class \fBInteger\fP)
Specify the shuffle ticks. Sort block by (1000000/shuffleTicks) micro sec.
Default value is 10. 
.TP 8
.B puzzleSteps \fR(class \fBInteger\fP)
Specify the block size.
Default value is 100 (100x100 pixels).
.TP 8
.B fileList \fR(class \fBString\fP)
Specify the file list of GIF and JPEG.

.SH HOW TO USE
With the xscreensaver (Created by Jamie Zawinski <jwz@lucid.com>,

.nf
List the GIF and JPEG file names in XSlideshow.
.nf
Set xscreensaver's resource XScreenSaver as below.

.nf
.ft B
*colorPrograms:\\
	xslideshow -animate slide -root      \\n\\
	xslideshow -animate fade -root       \\n\\
	xslideshow -animate flush -root      \\n\\
	xslideshow -animate monotone -root   \\n\\
	xslideshow -animate reverse -root    \\n\\
	xslideshow -animate wipe -root       \\n\\
	xslideshow -animate block -root      \\n\\
	xslideshow -animate mosaic -root     \\n\\
	xslideshow -animate coloranim -root  \\n\\
	xslideshow -animate coloranim2 -root \\n\\
	xslideshow -animate shuffle -root    \\n\\
	xslideshow -animate puzzle -root     \\n\\
	xslideshow -animate move -root       \\n


.SH COPYRIGHT
See vroot.h, reduce.c, gif2gimage.c, jpg2gimage.c.
The others Copyright by Susumu Shiohara.
Permission to use, copy, modify, distribute, and sell this software and
its documentation for any purposes are hereby granted without fee,
provided that the above copyright notice appears in all copies and that
both copyright and this permission notices appear in 
supporting documentation.  No representations are made about the
suitability of this software for any purposes. 
It is provided "as is" without express or implied warranty.

.SH SEE ALSO
.BR xv (1),
.BR xloadimage (1),
.BR xscreensaver (1)

 
.SH AUTHOR
Susumu Shiohara (shiohara@io.tpp.epson.co.jp).
Please let me know if you find any bugs or make any improvements.
Thanks to (yamaoka@ga.sony.co.jp) for debug xslideshow.
Thanks to (Yasuhiro.Suzuki@EBay.Sun.COM) for create SYSV patches, and this manual.

