#!/bin/csh -f
#  Copyright 1993 by Katsumi Yamaoka <yamaoka@ga.sony.co.jp>
#
#  XSlideshow.skel is a file cutting out "*fileList" lines from XSlideshow
#  Specify set USER =set FILEDIR = set dirs = .
#  This example means that user name is yamaokaand there are sub-directories 
#  HDIR1,HDIR2,HDIR3,HDIR4,DIR1,DIR2,DIR3,DIR4 in the directory /var/pictures/gif
#
#  Create a directory named ".app-defaults" in your home dir.
#  Put XSlideshow.skel into ~/.app-defaults.
#
#  Specify XScreenSaver to exec this shell script.
#
set USER = yamaoka
set FILEDIR = /var/pictures/gif
set path = (/usr/ucb /bin /usr/local/bin/X11)
setenv PATH `echo $path | sed 's/ /:/g'`
setenv DISPLAY `hostname`':0.0'
setenv XAPPLRESDIR $HOME/.app-defaults
#
@ Random1 = $$ - (($$ / 100) * 100)
@ Rx = $Random1 / 10
@ Ry = $Random1 - ($Rx * 10)
set Random2 = $Ry$Rx
#
chdir $XAPPLRESDIR
#
echo '*fileList:\' >> XSlideshow
@ Hour = `date '+%H'`
chdir $FILEDIR
#
# There are special pictures( such as Xrated ???) in HDIR1....
if ($Hour < 6 || $Hour > 21) then
  set dirs = (HDIR1 HDIR2 HDIR3 HDIR4)
#
# There are artistic pictures in DIR1....
else
  set dirs = (DIR1 DIR2 DIR3 DIR4)
endif
#
@ ndir = (($Random2 * $#dirs) / 100) + 1
chdir $dirs[$ndir]
@ filesM1 = `ls | wc -l` - 1
ls | head -$filesM1 | \
  sed -e 's/^/  /g' -e 's/$/\\n\\/g' >> $XAPPLRESDIR/XSlideshow
ls | tail -1 | \
  sed -e 's/^/  /g' -e 's/$/\\n/g' >> $XAPPLRESDIR/XSlideshow
#
#
if (`whoami` == root) /etc/chown $USER $XAPPLRESDIR/XSlideshow
#
exec xslideshow -root

